<template>
  <app-header />
  <div class="messages">
    <template v-if="events_chats || organisations_chats">
      <div class="container">
        <div class="messages-tabs">
          <v-tabs v-model="selected_tab" color="blue" grow>
            <v-tab
              v-for="tab in messages_tabs"
              :key="tab.value"
              :value="tab.value"
            >
              <v-icon>{{ tab.icon }}</v-icon>
              {{ tab.title }}
            </v-tab>
          </v-tabs>
        </div>
        <div class="messages-chats" v-if="selected_tab === 'events'">
          <router-link
            :to="{ name: 'Chat', params: { id: chat.id } }"
            class="chat-preview"
            v-for="chat in events_chats"
            :key="chat.id"
          >
            <div
              class="chat-icon"
              :style="{
                background: `url(${
                  chat.chatable.avatar
                    ? chat.chatable.avatar.url.full_size
                    : require('../../assets/splash.svg')
                }) no-repeat center center`,
              }"
            />
            <div class="chat-description">
              <h3>{{ chat.chatable.name }}</h3>
            </div>
          </router-link>
        </div>
        <div class="messages-chats" v-else>
          <router-link
            :to="{ name: 'Chat', params: { id: chat.id } }"
            class="chat-preview"
            v-for="chat in organisations_chats"
            :key="chat.id"
          >
            <div
              class="chat-icon"
              :style="{
                background: `url(${
                  chat.chatable.avatar
                    ? chat.chatable.avatar.url.full_size
                    : require('../../assets/splash.svg')
                }) no-repeat center center`,
              }"
            />
            <div class="chat-description">
              <h3>{{ chat.chatable.name }}</h3>
            </div>
            <div class="chat-info">
              <p v-if="chat.messages.length">
                {{
                  chat.messages
                    .slice(0, -1)[0]
                    .created_at.split("T")[1]
                    .split(":")[0]
                }}
                :
                {{
                  chat.messages
                    .slice(0, -1)[0]
                    .created_at.split("T")[1]
                    .split(":")[1]
                }}
              </p>
            </div>
          </router-link>
        </div>
      </div>
    </template>
    <div class="messages-loader" v-else>
      <app-loader label="Загружаем чаты" />
    </div>
  </div>
</template>

<script>
import AppHeader from "@/components/AppHeader";
import { mapActions } from "vuex";
import AppLoader from "@/components/AppLoader";
export default {
  name: "MessagesView",
  components: { AppLoader, AppHeader },

  data() {
    return {
      selected_tab: "organisations",
      messages_tabs: [
        {
          title: "Чат организаций",
          icon: "mdi-home-city-outline",
          value: "organisations",
        },
        {
          title: "Чат событий",
          icon: "mdi-account-outline",
          value: "events",
        },
      ],
      events_chats: "",
      organisations_chats: "",
    };
  },

  methods: {
    ...mapActions({
      loadEventsChats: "chat/loadEventsChats",
      loadOrganisationsChats: "chat/loadOrganisationsChats",
    }),
  },

  mounted() {
    this.loadEventsChats().then((response) => {
      this.events_chats = response.data.data;
    });
    this.loadOrganisationsChats().then((response) => {
      this.organisations_chats = response.data.data;
    });
  },
};
</script>

<style scoped lang="scss">
.messages {
  max-width: 425px;
  margin: 0 auto;
  padding: 0 0 64px;
  &-loader {
    margin: 45% 0 0;
    display: flex;
    align-items: center;
    justify-content: center;
  }
}

.chat {
  &-preview {
    display: grid;
    grid-template-columns: 64px 1fr auto;
    grid-gap: $base-space * 2;
    align-items: center;
    padding: ($base-space * 2) 0;
    border-bottom: 1px solid rgba(42, 49, 74, 0.2);
  }
  &-icon {
    height: 64px;
    background-size: cover !important;
    border-radius: 4px;
  }
  &-description {
    > h3 {
      font-style: normal;
      font-weight: 500;
      font-size: 14px;
      line-height: 18px;
      color: #212121;
      margin: 0 0 ($base-space);
    }
  }
  &-info {
    display: flex;
    flex-flow: column;
    justify-content: flex-end;
    align-items: flex-end;
    > p {
      font-weight: 400;
      font-size: 12px;
      line-height: 18px;
      color: #727272;
    }
    > span {
      display: flex;
      align-items: center;
      justify-content: center;
      padding: 4px 6px;
      border-radius: 12px;
      font-style: normal;
      font-weight: 400;
      font-size: 12px;
      line-height: 12px;
      color: $white;
      background: $blue;
    }
  }
}
</style>
